
class Aiguille; class Zone; class Signal; class Itineraire;

/////////////////////////////////////////////////////////////////////////////

#include "AiguilleEtZone.h"
#include "Signal.h"
#include "Itineraire.h"

/////////////////////////////////////////////////////////////////////////////

// les zones reelles, a ecrire par l'utilisateur

class Z8 : public Zone { // héritage de Zone
public:
  Z8(int n):Zone(n) {} // constructeur mini
  Z8(char* nm,int t,int n):Zone(nm,t,n) {} // constructeur maxi
  virtual void actions();
  virtual void desactions();
  virtual Zone* suivantePaire();
  virtual Zone* suivanteImpaire();
};

class Z9 : public Zone { // héritage de Zone
public:
  Z9(int n):Zone(n) {} // constructeur mini
  Z9(char* nm,int t,int n):Zone(nm,t,n) {} // constructeur maxi
  virtual void actions();
  virtual void desactions();
  virtual Zone* suivantePaire();
  virtual Zone* suivanteImpaire();
};

class Z10 : public Zone { // héritage de Zone
public:
  Z10(int n):Zone(n) {} // constructeur mini
  Z10(char* nm,int t,int n):Zone(nm,t,n) {} // constructeur maxi
  virtual void actions();
  virtual void desactions();
  virtual Zone* suivantePaire();
  virtual Zone* suivanteImpaire();
};

/////////////////////////////////////////////////////////////////////////////
// declarations, a ecrire par l'utilisateur

Signal* c2=new Signal(); // signaux
Signal* s5=new Signal(); 

Zone* z8=new Z8(5); // zones
Zone* z9=new Z9("Z9",SENS_IMPAIR_OU_PAIR,7); 
Zone* z10=new Z10(3); 

Zone* tableZones[] {z8,z9,z10}; // la table des zones pour la retrosignalisation

Aiguille* aig1=new Aiguille(1); // aiguilles
Aiguille* aig2=new Aiguille(2); 
Aiguille* aig3=new Aiguille(7); 

Itineraire* it; // itineraire

/////////////////////////////////////////////////////////////////////////////
// les methodes des zones, a ecrire par l'utilisateur

void Z8::actions() { c2->aubiner(); }
void Z8::desactions() {}
Zone* Z8::suivantePaire() { return z10; }
Zone* Z8::suivanteImpaire() { return z9; }

void Z9::actions() {}
void Z9::desactions() { s5->desaubiner(); }
Zone* Z9::suivantePaire() { return z8; }
Zone* Z9::suivanteImpaire() { return NULL; }

void Z10::actions() {}
void Z10::desactions() { it->detruire(); }
Zone* Z10::suivantePaire() { return z8; }
Zone* Z10::suivanteImpaire() { return selonAiguille(aig1,z8,z9); }

/////////////////////////////////////////////////////////////////////////////

void setup() {}

void loop() {}

